package com.redhat.jboss.support;

import org.jboss.system.ServiceMBeanSupport;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class HelloService extends ServiceMBeanSupport implements HelloServiceMBean {

    //private String message = "Hello World!";
    private String message; 

    private ScheduledExecutorService pool = Executors.newScheduledThreadPool(1);
    private Runnable task;

    @Override
    public void createService() throws Exception {
        super.createService();
        System.out.println("HelloService.createService()");
    }
    @Override
    public void startService() throws Exception {
        super.startService();
        System.out.println("HelloService.startService()");

	System.out.println("start:" + task);
        if(task == null) {
            throw new IllegalStateException("Null task");
        }
    
        System.out.println(">>start:task=" + task);
        // pool.schedule(task, 1000, TimeUnit.MILLISECONDS);
        // pool.scheduleWithFixedDelay(task, 1000, 1000, TimeUnit.MILLISECONDS);
        pool.scheduleWithFixedDelay(task, 1000, 1000*10, TimeUnit.MILLISECONDS);
        System.out.println("<<start:task=" + task);


    }
    @Override
    public void stopService() throws Exception {
        super.stopService();
        System.out.println("HelloService.stopService()");

        System.out.println("stop:" + task);
    
        System.out.println(">>stop");
        pool.shutdown();
        System.out.println("<<stop");

    }
    @Override
    public void destroyService() throws Exception {
        super.destroyService();
        System.out.println("HelloService.destroyService()");
    }
    
    @Override
    public void setMessage(String message) {
        System.out.println("HelloService.setMessage(): " + message);
        this.message = message; 
    }

    @Override
    public String getMessage() {
        System.out.println("HelloService.getMessage(): " + message);
	return message;
    }

    @Override
    public String hello() {
        System.out.println("HelloService.hello()");
	return message;
    }

    public void setTask(Runnable task) {
        System.out.println("HelloService.setTask(): " + task);
        this.task = task;
    }  

}
